/****************************************************************************
*		گ޻ (Dhrystone,Whetstone)		ްޮ 0.01	1998.07.04	*
*****************************************************************************

	VC++ 5.0 : ߲

	C++ Builder 3 : bcc32 -tW Bench.cpp Dhry.c Whet.c

	Ql : Interface 1998N5 Win32APIŊwWindows۸ݸލē
			   (WindowQlɂ)

*/

#include <windows.h>
#include <stdlib.h>
#include <process.h>

#define	PWM_DHRY		(WM_USER + 1)
#define	PWM_WHET		(WM_USER + 2)
#define ID_DhryLabel	101
#define ID_WhetLabel	102
#define ID_DhryBtn		103
#define ID_WhetBtn		104
#define ID_BothBtn		105

class TBenchThread					// ϰگޥ׽
{
private:
	int			FPriority;			// ϰگ ޭٗDx
	HANDLE		FBenchThread;		// ϰگ
	DWORD		FBenchThreadID;		// ϰگID
	bool		FFinished;			// ϰگޏI׸
	HWND		FhWnd;				// ޳
public:
	TBenchThread(LPTHREAD_START_ROUTINE lpStartAddress, HWND hWnd);
	~TBenchThread(void);
	HANDLE GetBenchThread(void) {return FBenchThread;}	// ϰگ
	static DWORD WINAPI ThreadDhryProc(LPVOID lpThreadParameter);// Dhrystoneگ
	static DWORD WINAPI ThreadWhetProc(LPVOID lpThreadParameter);// Whetstoneگ
};

class TBenchmark {					// ϰ׽
private:
	HWND hWndDhry;					// Dhrystone\pè۰ق
	HWND hWndWhet;					// Whetstone\pè۰ق
	TBenchThread *pThread[2];
public:
	TBenchmark(HWND hWnd);
	~TBenchmark();
	void SethWnd(HWND Dhry, HWND Whet);	// ق̐ݒ
	void ResumeThread(int ThreadNo);
	void DispDhry(UINT Dhry);		// Dhrystone̕\
	void DispWhet(UINT Whet);		// Whetstone̕\
};

#ifdef  __cplusplus
extern "C" {
#endif
extern int Dhrystone(long *dhrystones);
extern int Whetstone(double *Kwhets);
#ifdef  __cplusplus
}
#endif
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

TBenchmark *pBench;		// ۰قTBenchmark׽ւ߲

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpszCmdLine, int nCmdShow)
{
	MSG			msg;
	HWND		hWnd;
	WNDCLASSEX	wndclass;				// V鳲޸׽

	wndclass.style			 = 0;
	wndclass.lpfnWndProc	 = WndProc;	//̸׽̎³ޥۼެ
	wndclass.cbClsExtra		 = 0;
	wndclass.cbWndExtra		 = 0;
	wndclass.cbSize			 = sizeof(WNDCLASSEX);		//exŒǉ
	wndclass.hInstance		 = hInstance;
	wndclass.hIcon			 = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hIconSm		 = LoadIcon(NULL, IDI_WINLOGO);	//exŒǉ
	wndclass.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	 = GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	 = NULL;
	wndclass.lpszClassName	 = "benchmark";	// ̸׽̖O

	if(!RegisterClassEx(&wndclass))
		return 0;						// ޸׽̓o^
	hWnd = CreateWindow("benchmark",	// ׽̖O
			"MultiThread benchmark",
			WS_OVERLAPPEDWINDOW,		// ޳̑
			CW_USEDEFAULT, CW_USEDEFAULT,
			300, 200,
			HWND_DESKTOP,				// eިį
			NULL, hInstance, NULL);
	pBench = new TBenchmark(hWnd);
	pBench->SethWnd(CreateWindow("STATIC", "Dhrystone",	// \p۰ق׽ɒm点
			SS_RIGHT | WS_CHILD | WS_VISIBLE,	// ޳̑
			30, 20, 100, 30,
			hWnd, (HWND)ID_DhryLabel, hInstance, NULL),
			CreateWindow("STATIC", "Whetstone",	// \p۰ق׽ɒm点
			SS_RIGHT | WS_CHILD | WS_VISIBLE,	// ޳̑
			30, 60, 100, 30,
			hWnd, (HWND)ID_WhetLabel, hInstance, NULL));
	CreateWindow("BUTTON",	"DHRY",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,	// ޳̑
			180, 20, 60, 30,
			hWnd, (HWND)ID_DhryBtn, hInstance, NULL);
	CreateWindow("BUTTON",	"WHET",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,	// ޳̑
			180, 60, 60, 30,
			hWnd, (HWND)ID_WhetBtn, hInstance, NULL);
	CreateWindow("BUTTON",	"BOTH",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,	// ޳̑
			180, 100, 60, 30,
			hWnd, (HWND)ID_BothBtn, hInstance, NULL);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	delete pBench;
	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,	UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg) {
	case WM_COMMAND:
		switch (wParam) {
		case ID_DhryBtn:
			pBench->DispDhry(0);	// Dhrystone̕\ؾ
			pBench->ResumeThread(0);
			return 0;
		case ID_WhetBtn:
			pBench->DispWhet(0);	// Whetstone̕\ؾ
			pBench->ResumeThread(1);
			return 0;
		case ID_BothBtn:
			pBench->DispDhry(0);	// Dhrystone̕\ؾ
			pBench->DispWhet(0);	// Whetstone̕\ؾ
			pBench->ResumeThread(0);
			pBench->ResumeThread(1);
			return 0;
		}
		break;
	case PWM_DHRY:
		pBench->DispDhry(wParam);	// Dhrystone̕\
		return 0;
	case PWM_WHET:
		pBench->DispWhet(wParam);	// Whetstone̕\
		return 0;
	case WM_DESTROY:				// KKvCDefWindowProcł͏Ȃ
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, Msg, wParam, lParam);
}

// TBenchThread

TBenchThread::TBenchThread(LPTHREAD_START_ROUTINE lpStartAddress, HWND hWnd)
{
	FPriority		= THREAD_PRIORITY_HIGHEST;	// ϰگ ޭٗDx
	FFinished		= false;		// ϰگޏI׸
	FhWnd			= hWnd;			// ޳
	FBenchThread	= (HANDLE)		// ϰگ
		_beginthreadex(NULL, 0,
					   (unsigned (__stdcall *) (void *))lpStartAddress,
					   this, 0, (unsigned *)&FBenchThreadID);
	SetThreadPriority(FBenchThread, FPriority);
}

TBenchThread::~TBenchThread(void)
{
	if (FBenchThread) {
		FFinished = true;			// ϰگޏI׸
		ResumeThread(FBenchThread);
		WaitForSingleObject(FBenchThread, INFINITE);
		CloseHandle(FBenchThread);	// ϰگ ۰
		FBenchThreadID = 0;
		FBenchThread   = NULL;
	}
}

// Dhrystoneگ

DWORD WINAPI TBenchThread::ThreadDhryProc(LPVOID lpThreadParameter)
{
	TBenchThread *FBench = (TBenchThread *)lpThreadParameter;
	long dhrystones;

	while (FBench && !FBench->FFinished) {
		SuspendThread(FBench->FBenchThread);
		if (!FBench->FFinished) {
//			PostMessage(FBench->FhWnd, PWM_DHRY, 0, 0);
			Dhrystone(&dhrystones);
			PostMessage(FBench->FhWnd, PWM_DHRY, dhrystones, 0);
		}
	}
	return 0;
}

// Whetstoneگ

DWORD WINAPI TBenchThread::ThreadWhetProc(LPVOID lpThreadParameter)
{
	TBenchThread *FBench = (TBenchThread *)lpThreadParameter;
	double Kwhets;

	while (FBench && !FBench->FFinished) {
		SuspendThread(FBench->FBenchThread);
		if (!FBench->FFinished) {
//			PostMessage(FBench->FhWnd, PWM_WHET, 0, 0);
			Whetstone(&Kwhets);
			PostMessage(FBench->FhWnd, PWM_WHET, (UINT)(100.0 * Kwhets), 0);
		}
	}
	return 0;
}

// TBenchmark

TBenchmark::TBenchmark(HWND hWnd)
{
	pThread[0] = new TBenchThread(TBenchThread::ThreadDhryProc, hWnd);
	pThread[1] = new TBenchThread(TBenchThread::ThreadWhetProc, hWnd);
}

TBenchmark::~TBenchmark()
{
	delete pThread[0];
	delete pThread[1];
}

void TBenchmark::SethWnd(HWND Dhry, HWND Whet)
{
	hWndDhry = Dhry, hWndWhet = Whet;	// ق̐ݒ
}

void TBenchmark::ResumeThread(int ThreadNo)
{
	if (ThreadNo < sizeof(pThread) / sizeof(pThread[0]))
		::ResumeThread(pThread[ThreadNo]->GetBenchThread());
}

void TBenchmark::DispDhry(UINT Dhry)
{
	char cbuf[50];

	wsprintf(cbuf, "%u", Dhry);
	SetWindowText(hWndDhry, cbuf);		// Dhrystone̕\
}

void TBenchmark::DispWhet(UINT Whet)
{
	char cbuf[50];

	_gcvt((double)Whet / 100.0, 10, cbuf);
	SetWindowText(hWndWhet, cbuf);		// Whetstone̕\
}
