/****************************************************************************
*		گ޻ (r)				ްޮ 0.01	1998.06.28	*
*****************************************************************************

	VC++ 5.0 : ߲

	C++ Builder 3 : bcc32 -tW Exclusiv.cpp

	Ql : Interface 1998N5 Win32APIŊwWindows۸ݸލē
			   (WindowQlɂ)

*/

#include <windows.h>
#include <process.h>

#define	XCtrlCritical	1	// CriticalSectionɂr
#define	XCtrlMutex		2	// Mutexɂr
#define	XCtrlSemaphore	3	// Semaphoreɂr
#define	XCtrlType		XCtrlMutex // XCtrlCritical // XCtrlSemaphore

#define	PWM_COUNT		(WM_USER + 1)
#define ID_Label0		101
#define ID_Label1		102
#define ID_Label2		103
#define ID_Label3		104
#define ID_ExclusiveBtn	105
#define	PublicCountINIT	10

class TSampleThread					// ٥گޥ׽
{
private:
	HANDLE		FSampleThread;		// ٥گ
	DWORD		FSampleThreadID;	// ٥گID
	bool		FFinished;			// ٥گޏI׸
	HWND		hWndMain;			// ޳
public:
	TSampleThread(LPTHREAD_START_ROUTINE lpStartAddress, HWND hWnd);
	~TSampleThread(void);
	static DWORD WINAPI Thread0Proc(LPVOID lpThreadParameter);	// گ0
	static DWORD WINAPI Thread1Proc(LPVOID lpThreadParameter);	// گ1
};

class TDisp {						// \׽
private:
	HWND hWndEqu;					// \pè۰ق
	HWND hWndNeq;					// \pè۰ق
	HWND hWndBtn;					// rON/OFFt۰ق
	TSampleThread *pSample[2];
public:
	TDisp(HWND hWnd);
	~TDisp();
	void SethWnd(HWND hEqu, HWND hNeq, HWND hBtn);	// ق̐ݒ
	void DispExclusive(LONG lExclusive);	// rON/OFF̕\
	void DispCount(LONG Count, bool bInit);	// ̕\
};

#if	XCtrlType == XCtrlCritical	// è٥݂ɂr
class TExclusiveCtrl {
private:
	CRITICAL_SECTION critical_section;
public:
	TExclusiveCtrl() {InitializeCriticalSection(&critical_section);}
	~TExclusiveCtrl() {DeleteCriticalSection(&critical_section);}
	DWORD WaitFor() {EnterCriticalSection(&critical_section);
					 return WAIT_OBJECT_0;}
	void Release() {LeaveCriticalSection(&critical_section);}
};
#endif
#if	XCtrlType == XCtrlMutex		// Эïɂr
class TExclusiveCtrl {
private:
	HANDLE	hMutex;
public:
	TExclusiveCtrl() {hMutex = CreateMutex(NULL, FALSE, NULL);}
	~TExclusiveCtrl() {CloseHandle(hMutex);}
	DWORD WaitFor() {return WaitForSingleObject(hMutex, INFINITE);}
	void Release() {ReleaseMutex(hMutex);}
};
#endif
#if	XCtrlType == XCtrlSemaphore	// ̫ɂr
class TExclusiveCtrl {
private:
	HANDLE	hSemaphore;
public:
	TExclusiveCtrl() {hSemaphore = CreateSemaphore(NULL, 1, 1, NULL);}
	~TExclusiveCtrl() {CloseHandle(hSemaphore);}
	DWORD WaitFor() {return WaitForSingleObject(hSemaphore, INFINITE);}
	void Release() {ReleaseSemaphore(hSemaphore, 1, NULL);}
};
#endif

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

TDisp *pDisp;				// ۰قTDisp׽ւ߲
TExclusiveCtrl *pXCtrl;		// r
LONG lPublicCount = PublicCountINIT;	// 
LONG lExclusive = true;		// r

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpszCmdLine, int nCmdShow)
{
	MSG			msg;
	HWND		hWnd;
	WNDCLASSEX	wndclass;				// V鳲޸׽

	wndclass.style			 = 0;
	wndclass.lpfnWndProc	 = WndProc;	//̸׽̎³ޥۼެ
	wndclass.cbClsExtra		 = 0;
	wndclass.cbWndExtra		 = 0;
	wndclass.cbSize			 = sizeof(WNDCLASSEX);		//exŒǉ
	wndclass.hInstance		 = hInstance;
	wndclass.hIcon			 = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hIconSm		 = LoadIcon(NULL, IDI_WINLOGO);	//exŒǉ
	wndclass.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	 = GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	 = NULL;
	wndclass.lpszClassName	 = "exclusive";	// ̸׽̖O

	if(!RegisterClassEx(&wndclass))
		return 0;						// ޸׽̓o^
	pXCtrl = new TExclusiveCtrl();
	hWnd = CreateWindow("exclusive",	// ׽̖O
			"MultiThread example",
			WS_OVERLAPPEDWINDOW,		// ޳̑
			CW_USEDEFAULT, CW_USEDEFAULT,
			400, 150,
			HWND_DESKTOP,				// eިį
			NULL, hInstance, NULL);
	pDisp = new TDisp(hWnd);
	CreateWindow("STATIC", " == 10",
			SS_RIGHT | WS_CHILD | WS_VISIBLE,		// ޳̑
			20, 20, 100, 30,
			hWnd, (HWND)ID_Label0, hInstance, NULL);
	CreateWindow("STATIC", " != 10",
			SS_RIGHT | WS_CHILD | WS_VISIBLE,		// ޳̑
			20, 60, 100, 30,
			hWnd, (HWND)ID_Label1, hInstance, NULL);
	pDisp->SethWnd(CreateWindow("STATIC", "0",	// \p۰ق׽ɒm点
			SS_RIGHT | WS_CHILD | WS_VISIBLE,		// ޳̑
			140, 20, 100, 30,
			hWnd, (HWND)ID_Label2, hInstance, NULL),
			CreateWindow("STATIC", "0",	// \p۰ق׽ɒm点
			SS_RIGHT | WS_CHILD | WS_VISIBLE,		// ޳̑
			140, 60, 100, 30,
			hWnd, (HWND)ID_Label3, hInstance, NULL),
			CreateWindow("BUTTON",	"r ON",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,	// ޳̑
			260, 20, 110, 30,
			hWnd, (HWND)ID_ExclusiveBtn, hInstance, NULL));

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	delete pDisp;
	delete pXCtrl;
	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,	UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static bool bChanging;

	switch (Msg) {
	case WM_COMMAND:
		switch (wParam) {
		case ID_ExclusiveBtn:
			pDisp->DispExclusive(-1);			// rON/OFFω
			bChanging = true;
			lExclusive = !lExclusive;			// r
			pDisp->DispCount(0, true);			// ؾ
			pDisp->DispExclusive(lExclusive);	// rON/OFF̕\
			return 0;
		}
		break;
	case PWM_COUNT:
		if (lParam == (LPARAM)lExclusive)		// rON/OFFؑ֍ ?
			if (bChanging)
				bChanging = false;
			else
				pDisp->DispCount(wParam, false);// ̕\
		return 0;
	case WM_DESTROY:				// KKvCDefWindowProcł͏Ȃ
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, Msg, wParam, lParam);
}

// TSampleThread

TSampleThread::TSampleThread(LPTHREAD_START_ROUTINE lpStartAddress, HWND hWnd)
{
	FFinished		= false;		// ٥گޏI׸
	hWndMain		= hWnd;			// ޳
	FSampleThread	= (HANDLE)		// ٥گ
		_beginthreadex(NULL, 0,
					   (unsigned (__stdcall *) (void *))lpStartAddress,
					   this, 0, (unsigned *)&FSampleThreadID);
	SetThreadPriority(FSampleThread, THREAD_PRIORITY_LOWEST);
}

TSampleThread::~TSampleThread(void)
{
	if (FSampleThread) {
		FFinished = true;			// ٥گޏI׸
		ResumeThread(FSampleThread);
		WaitForSingleObject(FSampleThread, INFINITE);
		CloseHandle(FSampleThread);	// ٥گ ۰
		FSampleThreadID = 0;
		FSampleThread   = NULL;
	}
}

DWORD WINAPI TSampleThread::Thread0Proc(LPVOID lpThreadParameter)	// گ0
{
	TSampleThread *FSample = (TSampleThread *)lpThreadParameter;

	while (FSample && !FSample->FFinished) {
		if (!lExclusive) {
			InterlockedIncrement(&lPublicCount);
			PostMessage(FSample->hWndMain, PWM_COUNT,
						lPublicCount - 1, lExclusive);
			InterlockedDecrement(&lPublicCount);
		} else if (pXCtrl && pXCtrl->WaitFor() == WAIT_OBJECT_0) {
			lPublicCount++;
			PostMessage(FSample->hWndMain, PWM_COUNT,
						lPublicCount - 1, lExclusive);
			lPublicCount--;
			pXCtrl->Release();
		}
		Sleep(1);
	}
	return 0;
}

DWORD WINAPI TSampleThread::Thread1Proc(LPVOID lpThreadParameter)	// گ1
{
	TSampleThread *FSample = (TSampleThread *)lpThreadParameter;

	while (FSample && !FSample->FFinished) {
		if (!lExclusive) {
			InterlockedDecrement(&lPublicCount);
			PostMessage(FSample->hWndMain, PWM_COUNT,
						lPublicCount + 1, lExclusive);
			InterlockedIncrement(&lPublicCount);
		} else if (pXCtrl && pXCtrl->WaitFor() == WAIT_OBJECT_0) {
			lPublicCount--;
			PostMessage(FSample->hWndMain, PWM_COUNT,
						lPublicCount + 1, lExclusive);
			lPublicCount++;
			pXCtrl->Release();
		}
		Sleep(1);
	}
	return 0;
}

// TDisp

TDisp::TDisp(HWND hWnd)
{
	pSample[0] = new TSampleThread(TSampleThread::Thread0Proc, hWnd);
	pSample[1] = new TSampleThread(TSampleThread::Thread1Proc, hWnd);
}

TDisp::~TDisp()
{
	delete pSample[0];
	delete pSample[1];
}

void TDisp::SethWnd(HWND hEqu, HWND hNeq, HWND hBtn)	// ق̐ݒ
{
	hWndEqu = hEqu;					// \pè۰ق
	hWndNeq = hNeq;					// \pè۰ق
	hWndBtn	= hBtn;					// rON/OFFt۰ق
}

void TDisp::DispExclusive(LONG lExclusive)	// rON/OFF̕\
{
	if (lExclusive > 0)
		SetWindowText(hWndBtn, "r ON");
	else if (lExclusive == 0)
		SetWindowText(hWndBtn, "r OFF");
	else /* if (lExclusive < 0) */
		SetWindowText(hWndBtn, "r ...");
}

void TDisp::DispCount(LONG Count, bool bInit)
{
	static UINT uEquCnt,			// lPublicCount == PublicCountINIT
				uNeqCnt;			// lPublicCount != PublicCountINIT
	char cbuf[50];

	if (bInit) {
		uEquCnt = 0;				// lPublicCount == PublicCountINIT
		uNeqCnt = 0;				// lPublicCount != PublicCountINIT
		SetWindowText(hWndEqu, "0");	// \ؾ
		SetWindowText(hWndNeq, "0");	// \ؾ
	} else if (Count == PublicCountINIT) {
		if ((++uEquCnt % 10) == 0) {
			wsprintf(cbuf, "%u", uEquCnt);
			SetWindowText(hWndEqu, cbuf);	// ̕\
		}
	} else {
		wsprintf(cbuf, "%u", ++uNeqCnt);
		SetWindowText(hWndNeq, cbuf);	// ̕\
	}
}
