/****************************************************************************
*		گ޻ (گނɂ鉉Z)		ްޮ 0.01	1998.07.12	*
*****************************************************************************

	VC++ 5.0 : ߲

	C++ Builder 3 : bcc32 -tW MultiCpu.cpp

	Ql : Interface 1998N5 Win32APIŊwWindows۸ݸލē
			   (WindowQlɂ)

*/

#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include <process.h>

#define ID_StartBtn	100
#define ID_Label1	110
#define MAXTHREAD	20

class TBenchmark {					// Z׽
private:
	HWND	hWndCalc[MAXTHREAD + 1];// \pè۰ق
	HANDLE	hThread[MAXTHREAD];		// Zگ
	DWORD	dwThreadID[MAXTHREAD];	// ZگID
	static DWORD WINAPI ThreadCalcProc(LPVOID lpThreadParameter);// Zگ
public:
	TBenchmark() {}
	~TBenchmark() {}
	void SethWnd(int n, HWND hWnd);	// ق̐ݒ
	void Calculate(int ThreadNum);
};

struct calc_t {
	double *pAdr;					// ZJnڽ
	UINT   Count;					// Z
	double Result;					// Z
};

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

TBenchmark *pBench;		// ۰قTBenchmark׽ւ߲

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpszCmdLine, int nCmdShow)
{
	MSG			msg;
	HWND		hWnd;
	WNDCLASSEX	wndclass;				// V鳲޸׽

	wndclass.style			 = 0;
	wndclass.lpfnWndProc	 = WndProc;	//̸׽̎³ޥۼެ
	wndclass.cbClsExtra		 = 0;
	wndclass.cbWndExtra		 = 0;
	wndclass.cbSize			 = sizeof(WNDCLASSEX);		//exŒǉ
	wndclass.hInstance		 = hInstance;
	wndclass.hIcon			 = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hIconSm		 = LoadIcon(NULL, IDI_WINLOGO);	//exŒǉ
	wndclass.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	 = GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	 = NULL;
	wndclass.lpszClassName	 = "benchmark";	// ̸׽̖O

	if(!RegisterClassEx(&wndclass))
		return 0;						// ޸׽̓o^
	hWnd = CreateWindow("benchmark",	// ׽̖O
			"MultiThread benchmark",
			WS_OVERLAPPEDWINDOW,		// ޳̑
			CW_USEDEFAULT, CW_USEDEFAULT,
			290, 555,
			HWND_DESKTOP,				// eިį
			NULL, hInstance, NULL);
	pBench = new TBenchmark();
	for (int n = 0; n <= MAXTHREAD; n++) {
		char cbuf[20];

		wsprintf(cbuf, "گ%2u", n);
		pBench->SethWnd(n,
			CreateWindow("STATIC", cbuf,	// \p۰ق׽ɒm点
			SS_LEFT | WS_CHILD | WS_VISIBLE,	// ޳̑
			10, 40 + 23 * n, 260, 20,
			hWnd, (HWND)(ID_Label1 + n), hInstance, NULL));
	}
	CreateWindow("BUTTON",	"ZJn",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,	// ޳̑
			10, 5, 80, 30,
			hWnd, (HWND)ID_StartBtn, hInstance, NULL);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	delete pBench;
	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,	UINT Msg, WPARAM wParam, LPARAM lParam)
{
	int n;

	switch (Msg) {
	case WM_COMMAND:
		switch (wParam) {
		case ID_StartBtn:
			for (n = 0; n <= MAXTHREAD; n++)
				pBench->Calculate(n);
			return 0;
		}
		break;
	case WM_DESTROY:				// KKvCDefWindowProcł͏Ȃ
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, Msg, wParam, lParam);
}

// TBenchmark

void TBenchmark::SethWnd(int n, HWND hWnd)	// ق̐ݒ
{
	if (0 <= n && n <= MAXTHREAD)
		hWndCalc[n] = hWnd;
}

#define	RandomSize	720720L

void TBenchmark::Calculate(int ThreadNum)
{
	static double RandomBuf[RandomSize];
	DWORD dwStart, dwMsec;
	double total;
	char bresult[50], cbuf[50];
	int n;

	if (ThreadNum > MAXTHREAD)
		return;
	SetWindowText(hWndCalc[ThreadNum], "Calculate...");
	srand(1);
	for (n = 0; n < RandomSize; n++)
		RandomBuf[n] = (double)rand() / RAND_MAX;
	dwStart = GetTickCount();
	while (dwStart == (dwMsec = GetTickCount()))
		;
	dwStart = dwMsec;
	if (ThreadNum <= 0) {
		struct calc_t Calc;

		Calc.pAdr  = RandomBuf;		// ZJnڽ
		Calc.Count = RandomSize;	// Z
		ThreadCalcProc(&Calc);
		total = Calc.Result;		// Z
	} else {
		struct calc_t Calc[MAXTHREAD];
		double *pbuf;

		for (pbuf = RandomBuf, n = 0; n < ThreadNum; n++) {
			Calc[n].pAdr = pbuf;		// ZJnڽ
			if (n >= ThreadNum - 1)
				Calc[n].Count = RandomSize - (RandomSize / ThreadNum) * (ThreadNum - 1);
			else
				Calc[n].Count = RandomSize / ThreadNum;	// Z
			hThread[n] = (HANDLE)		// Zگ
				_beginthreadex(NULL, 0,
							   (unsigned (__stdcall *) (void *))ThreadCalcProc,
							   &Calc[n], 0, (unsigned *)&dwThreadID[n]);
			SetThreadPriority(hThread[n], THREAD_PRIORITY_HIGHEST);
										// Zگ ޭٗDx
			pbuf += Calc[n].Count;
		}
		WaitForMultipleObjects(ThreadNum, hThread, true, INFINITE);
		for (total = 0.0, n = 0; n < ThreadNum; n++) {
			total += Calc[n].Result;	// Z
			if (hThread[n]) {
				CloseHandle(hThread[n]);	// Zگ ۰
				dwThreadID[n] = 0;
				hThread[n]	  = NULL;
			}
		}
	}
	dwMsec = GetTickCount() - dwStart;
	_gcvt(total, 10, bresult);
	wsprintf(cbuf, "result%2u = %s, %u msec", ThreadNum, bresult, dwMsec);
	SetWindowText(hWndCalc[ThreadNum], cbuf);	// ZԂ̕\
}

static inline double dummycalc(double Data)	// ZԂ𒷂邽߂аZ
{
	return (Data * Data / Data) * (Data / (Data * Data)) *
			sqrt(Data * Data) / Data *
			sqrt(Data * Data) * sqrt(Data * Data) / (Data * Data) *
			sqrt(sqrt(Data * Data * Data * Data)) / Data *
			sqrt(Data * Data * Data) / sqrt(Data * Data * Data) *
			exp(log(Data)) * exp(log(Data)) / exp(log(Data));
}

// Zگ

DWORD WINAPI TBenchmark::ThreadCalcProc(LPVOID lpThreadParameter)
{
	struct calc_t *pCalc = (struct calc_t *)lpThreadParameter;
	double *pAdr;
	double Result;
	UINT n;

	for (Result = 0.0, pAdr = pCalc->pAdr, n = 0; n < pCalc->Count; n++) {
		double Data = *pAdr++;

		if (Data > 0) {				// ZԂ𒷂邽
#if	defined(_DEBUG) || defined(__BORLANDC__)
			Data = dummycalc(Data);
#else
			Data = dummycalc(Data) * dummycalc(Data) / dummycalc(Data);
#endif
		}
		Result += Data;
	}
	pCalc->Result = Result;
	return 0;
}
